﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web;

namespace LargeCookieModule
{
    public class LargeCookieModule : IHttpModule
    {
        public void Dispose()
        {
            throw new NotImplementedException();
        }

        public void Init(HttpApplication context)
        {
            context.BeginRequest += context_BeginRequest;
            context.EndRequest += context_EndRequest;
        }

        void context_BeginRequest(object sender, EventArgs e)
        {
            HttpApplication app = sender as HttpApplication;
            if (app != null)
            {
                if (app.Context.Request.ContentEncoding != null)
                    app.Context.Response.Write("app.Context.Request.ContentEncoding:" + app.Context.Request.ContentEncoding.ToString() + "<br />");

                app.Context.Response.Write("<br />-----------(start)raw request cookies, context_BeginRequest:--------------<br />");

                foreach (string key in app.Request.Cookies.AllKeys)
                {
                    HttpCookie cookie = app.Request.Cookies[key];
                    if (cookie != null)
                    {
                        string cookieString = CookieHelper.GetSetCookieHeaderString(app.Context, cookie);
                        app.Context.Response.Write("context_BeginRequest:" + cookieString + "<br />");
                        app.Context.Response.Write("context_BeginRequest.cookieLength:" + cookieString.Length + "<br />");
                        app.Context.Response.Write("context_BeginRequest.GetByteCount:" + System.Text.Encoding.UTF8.GetByteCount(cookieString) + "<br />");
                    }
                }

                app.Context.Response.Write("<br />-----------(end)raw request cookies, context_BeginRequest:--------------<br /><br />");

                app.Context.Response.Write("<br />-----------(start)merged by CookieHelper.cs, context_BeginRequest:--------------<br />");
                // 唯一一句用来过滤
                CookieHelper.FilterRequestCookies(app.Context);
                foreach (string key in app.Request.Cookies.AllKeys)
                {
                    HttpCookie cookie = app.Request.Cookies[key];
                    if (cookie != null)
                    {
                        string cookieString = CookieHelper.GetSetCookieHeaderString(app.Context, cookie);
                        app.Context.Response.Write("context_BeginRequest:" + cookieString + "<br />");
                        app.Context.Response.Write("context_BeginRequest.cookieLength:" + cookieString.Length + "<br />");
                        app.Context.Response.Write("context_BeginRequest.GetByteCount:" + System.Text.Encoding.UTF8.GetByteCount(cookieString) + "<br />");
                    }
                }
                app.Context.Response.Write("<br />-----------(end)merged by CookieHelper.cs, context_BeginRequest:--------------<br /><br />");
            }
        }

        void context_EndRequest(object sender, EventArgs e)
        {
            //HttpApplication app = sender as HttpApplication;
            //if (app != null)
            //{
            //    // CookieHelper.FilterResponseCookies(app.Context);
            //    app.Context.Response.Write("<br />-----------(start)response the merged cookies to the client, context_EndRequest:--------------<br />");
            //    foreach (string key in app.Response.Cookies.AllKeys)
            //    {
            //        HttpCookie cookie = app.Response.Cookies[key];
            //        if (cookie != null)
            //        {
            //            IList<HttpCookie> cookies = CookieHelper.GetSetCookies(app.Context, cookie);
            //            if (cookies != null)
            //            {
            //                foreach (HttpCookie subCookie in cookies)
            //                {
            //                    string cookieString = CookieHelper.GetSetCookieHeaderString(app.Context, subCookie);
            //                    app.Context.Response.AppendCookie(subCookie);
            //                    app.Context.Response.Write("context_EndRequest:" + cookieString + "<br />");
            //                    app.Context.Response.Write("context_EndRequest.cookieLength:" + cookieString.Length + "<br />");
            //                    app.Context.Response.Write("context_EndRequest.GetByteCount:" + System.Text.Encoding.UTF8.GetByteCount(cookieString) + "<br />");
            //                }
            //            }
            //        }
            //    }
            //    app.Context.Response.Write("<br />-----------(end)response the merged cookies to the client, context_EndRequest:--------------<br /><br />");
            //}

            HttpApplication app = sender as HttpApplication;
            if (app != null)
            {
                app.Context.Response.Write("<br />-----------(start)response the all cookies to the client, context_EndRequest:--------------<br />");

                CookieHelper.FilterResponseCookies(app.Context);

                List<HttpCookie> reverseList = new List<HttpCookie>();
                List<string> keys = app.Response.Cookies.AllKeys.ToList();
                foreach (string key in keys)
                {
                    HttpCookie cookie = app.Response.Cookies[key];
                    if (cookie != null)
                    {
                        reverseList.Add(cookie);
                        string cookieString = CookieHelper.GetSetCookieHeaderString(app.Context, cookie);
                        app.Context.Response.Write("context_EndRequest:" + cookieString + "<br />");
                        app.Context.Response.Write("context_EndRequest.cookieLength:" + cookieString.Length + "<br />");
                        app.Context.Response.Write("context_EndRequest.GetByteCount:" + System.Text.Encoding.UTF8.GetByteCount(cookieString) + "<br />");
                    }
                }

                app.Context.Response.Write("<br />-----------(end)response the all cookies to the client, context_EndRequest:--------------<br />");
            }
        }
    }
}
